import numpy as np
from numpy.linalg import norm

def bpIRLS(A, b, p):
    r"""
    Syntax:       xhat = bpIRLS(A, b, p)

    Inputs:
    -------
        A is a (N x D) matrix whose rows are the measurement locations
       
        b is a vector of length N whose values are the measurement values

        p is the norm to minimize

    Outputs:
    -------
        xhat is the vector of length D containing the approximate solution
    """

    # algorithm parameters
    eps = 1e-5
    tol = 1e-4
    maxIter = 1000

    ## Your code starts here
    for kk in range(maxIter):

        # stopping condition
        err = norm(xprev - xhat) / norm(xhat)
        if err < tol:
            break
