import numpy as np
from numpy.linalg import norm

def lassoADMM(A, b, lam):
    r"""
    Syntax:       xhat = lassoADMM(A, b, lam)

    Inputs:
    -------
        A is a (N x D) matrix whose rows are the measurement locations
       
        b is a vector of length N whose values are the measurement values

        lambda is the regularization tuning parameter

    Outputs:
    -------
        xhat is the vector of length D containing the approximate solution
    """

    # algorithm parameters
    rho = 10*lam
    tol = 1e-4
    maxIter = 1000

    ## Your code starts here
    for kk in range(maxIter):

        # stopping condition
        err = norm(w - z) / norm(w)
        if err < tol:
            break
