import numpy as np
import matplotlib.pyplot as plt
from lpIRLS import lpIRLS

np.random.seed(0)
N = 100

# generate data with outliers
a = 10
b = 5

xx = np.random.rand(N)
zz = np.zeros(N)
k = int(N*0.5)
rp = np.random.permutation(N)
outlier_subset = rp[:k]
zz[outlier_subset] = 1
yy = (1-zz)*(a*xx + b + np.random.randn(N)) + zz*(20 - 20*xx + 10*np.random.randn(N))

# plot observed data and true line
plt.figure()
plt.plot(xx, yy, 'x', label='observed points')
plt.plot(xx, a*xx + b, 'k--', label='true line')

## Your code
# Fit the data (xx,yy) using lp regression and plot for several values of p
