clear

alg = 'irls';       % set to 'irls' for Problem 2 or 'admm' for Problem 3

rng(0)              % use same data each time
p = 1;              % change this value if using IRLS
lambda = 0.1;       % change this value if using ADMM
varn = 0;           % leave at 0 for homework but you can play with this if you'd like
D = 500;            % problem size
nRange = round(linspace(5,D,10));       % range of number of measurements
sRange = round(linspace(1,0.2*D,11));   % range of sparsity levels - I take a different number so I know which axis is which when it's time to display

%% Your heatmap loop goes here
% Code to generate data for a given D, sparsity s, and N below.
% You need to put this in a loop over all values in nRange and sRange, then display the heatmap using either the imagesc or heatmap command.
N = nRange(1);
s = sRange(1);
supp = randsample(D,s);
xtrue = zeros(D,1);
xtrue(supp) = randn(s,1);
A = randn(N,D);
b = A*xtrue + varn*randn(N,1);
    
if strcmp(alg,'irls')
    % estimate x using IRLS
    xhat = bpIRLS(A,b,p);
elseif strcmp(alg,'admm')
    % estimate x using ADMM
    xhat = lassoADMM(A,b,lambda);
end
