import numpy as np
import matplotlib.pyplot as plt
from scipy import linalg
from bpIRLS import bpIRLS
from lassoADMM import lassoADMM

alg = 'irls'        # set to 'irls' for Problem 2 or 'admm' for Problem 3

np.random.seed(0)   # use same data each time
p = 1               # change this value if using IRLS
lam= 0.1            # change this value if using ADMM
varn = 0            # leave at 0 for homework but you can play with this if you'd like
D = 500             # problem size
nRange = np.round(np.linspace(5,D,10))       # range of number of measurements
sRange = np.round(np.linspace(1,0.2*D,11))   # range of sparsity levels - I take a different number so I know which axis is which when it's time to display

## Your heatmap loop goes here
# Code to generate data for a given D, sparsity s, and N below.
# You need to put this in a loop over all values in nRange and sRange, then display the heatmap using either the imshow command.
N = int(nRange[0])
s = int(sRange[0])
supp = np.random.permutation(D)[:s]
xtrue = np.zeros(D)
xtrue[supp] = np.random.randn(s)
A = np.random.randn(N,D)
b = A @ xtrue + varn*np.random.randn(N)
    
if alg == 'irls':
    # estimate x using IRLS
    #xhat = bpIRLS(A, b, p)
elif alg == 'admm':
    # estimate x using ADMM
    xhat = lassoADMM(A, b, lam)
